{-# LANGUAGE OverloadedStrings #-}

module Data.SMTP.Parser.Address (
  parseAddress,
  renderHeaderAddress,
  parseMetadataAddress,
  renderMetadataAddress
  ) where

import Data.Attoparsec.ByteString.Char8
import qualified Data.SMTP.URI as URI
import Data.SMTP.Types.Address
import Data.ByteString (ByteString)
import qualified Text.StringConvert as SC

parseAddress :: Parser Address
parseAddress = Address <$> URI.parseURI

renderHeaderAddress :: Address -> ByteString
renderHeaderAddress a = SC.s . show $ a

renderMetadataAddress :: Address -> ByteString
renderMetadataAddress = renderHeaderAddress

parseMetadataAddress :: Parser Address
parseMetadataAddress = parseAddress
